#include "common.ch"
#include "os.ch"
#define CRLF CHR(13)+CHR(10)

#PRAGMA LIBRARY("ASCOM10.LIB")


PROCEDURE Main(strComputer,cUser,cPassword)
LOCAL objWMIServices
LOCAL colItems
LOCAL cText
LOCAL cName
LOCAL bCollBlock
LOCAL i,iMax
LOCAL j,jMax
LOCAL aitem := {}
LOCAL aProp := {;
"Availability",;
"Capabilities",;
"CapabilityDescriptions",;
"Caption",;
"CompressionMethod",;
"ConfigManagerErrorCode",;
"ConfigManagerUserConfig",;
"CreationClassName",;
"DefaultBlockSize",;
"Description",;
"DeviceID",;
"Drive",;
"DriveIntegrity",;
"ErrorCleared",;
"ErrorDescription",;
"ErrorMethodology",;
"FileSystemFlags",;
"FileSystemFlagsEx",;
"Id",;
"InstallDate",;
"LastErrorCode",;
"Manufacturer",;
"MaxBlockSize",;
"MaximumComponentLength",;
"MaxMediaSize",;
"MediaLoaded",;
"MediaType",;
"MfrAssignedRevisionLevel",;
"MinBlockSize",;
"Name",;
"NeedsCleaning",;
"NumberOfMediaSupported",;
"PNPDeviceID",;
"PowerManagementCapabilities",;
"PowerManagementSupported",;
"RevisionLevel",;
"SCSIBus",;
"SCSILogicalUnit",;
"SCSIPort",;
"SCSITargetId",;
"Size",;
"Status",;
"StatusInfo",;
"SystemCreationClassName",;
"SystemName",;
"TransferRate",;
"VolumeName",;
"VolumeSerialNumber" }

DEFAULT strComputer TO "Localhost"
DEFAULT cUser       TO "Administrator"
DEFAULT cPassword   TO ""

   CLS

   SET ALTER TO Win32_CDROMDrive.TXT
   SET ALTER ON

   IF VAL( OS(OS_VERSION) ) > 6
      IF strComputer == "Localhost"
         objWMIServices  := CreateObject( "WbemScripting.SWbemLocator" ):ConnectServer(strComputer, "Root\CIMv2")
      ELSE
         IF EMPTY(cPassword)
            MSGBOX("Need Password")
            QUIT
         ELSE
            objWMIServices  := CreateObject( "WbemScripting.SWbemLocator" ):ConnectServer(strComputer, "Root\CIMv2",strComputer+"\"+cUser,cPassword)
         ENDIF
      ENDIF
   ELSE
      objWMIServices  := GetObject("WinMgmts:{impersonationLevel=impersonate}\\"+strComputer+"\Root\CIMv2") 
   ENDIF

   colItems       := objWMIServices:ExecQuery("select * from Win32_CDROMDrive",,48)
   bCollBlock     := {|oService,n| AADD(aItem,{ n,;
     oService:getProperty("Availability"),;
     oService:getProperty("Capabilities"),;
     oService:getProperty("CapabilityDescriptions"),;
     oService:getProperty("Caption"),;
     oService:getProperty("CompressionMethod"),;
     oService:getProperty("ConfigManagerErrorCode"),;
     oService:getProperty("ConfigManagerUserConfig"),;
     oService:getProperty("CreationClassName"),;
     oService:getProperty("DefaultBlockSize"),;
     oService:getProperty("Description"),;
     oService:getProperty("DeviceID"),;
     oService:getProperty("Drive"),;
     oService:getProperty("DriveIntegrity"),;
     oService:getProperty("ErrorCleared"),;
     oService:getProperty("ErrorDescription"),;
     oService:getProperty("ErrorMethodology"),;
     oService:getProperty("FileSystemFlags"),;
     oService:getProperty("FileSystemFlagsEx"),;
     oService:getProperty("Id"),;
     oService:getProperty("InstallDate"),;
     oService:getProperty("LastErrorCode"),;
     oService:getProperty("Manufacturer"),;
     oService:getProperty("MaxBlockSize"),;
     oService:getProperty("MaximumComponentLength"),;
     oService:getProperty("MaxMediaSize"),;
     oService:getProperty("MediaLoaded"),;
     oService:getProperty("MediaType"),;
     oService:getProperty("MfrAssignedRevisionLevel"),;
     oService:getProperty("MinBlockSize"),;
     oService:getProperty("Name"),;
     oService:getProperty("NeedsCleaning"),;
     oService:getProperty("NumberOfMediaSupported"),;
     oService:getProperty("PNPDeviceID"),;
     oService:getProperty("PowerManagementCapabilities"),;
     oService:getProperty("PowerManagementSupported"),;
     oService:getProperty("RevisionLevel"),;
     oService:getProperty("SCSIBus"),;
     oService:getProperty("SCSILogicalUnit"),;
     oService:getProperty("SCSIPort"),;
     oService:getProperty("SCSITargetId"),;
     oService:getProperty("Size"),;
     oService:getProperty("Status"),;
     oService:getProperty("StatusInfo"),;
     oService:getProperty("SystemCreationClassName"),;
     oService:getProperty("SystemName"),;
     oService:getProperty("TransferRate"),;
     oService:getProperty("VolumeName"),;
     oService:getProperty("VolumeSerialNumber") })}

   ComEvalCollection(colItems, bCollBlock )

   IF LEN(aItem) > 0
      ? "Win32_CDROMDrive"
      jMax := LEN(aItem)
      iMax := LEN(aItem[1])
      FOR j := 1 TO jMax
         ?"*****************************************************************************"
         FOR i := 1 TO iMax-1
            ? SUBSTR(aProp[i]+SPACE(40),1,40)+":",aItem[j,i+1]
         NEXT
         ?"*****************************************************************************"
      NEXT
   ELSE
      MSGBOX("no Property found ?")
   ENDIF

   SET ALTER OFF
   SET ALTER TO

   Runshell("Win32_CDROMDrive.TXT","Notepad.exe",.T.)

RETURN
