#include "common.ch"
#include "os.ch"
#define CRLF CHR(13)+CHR(10)

#PRAGMA LIBRARY("ASCOM10.LIB")


PROCEDURE Main(strComputer,cUser,cPassword)
LOCAL objWMIServices
LOCAL colItems
LOCAL cText
LOCAL cName
LOCAL bCollBlock
LOCAL i,iMax
LOCAL j,jMax
LOCAL aitem := {}
LOCAL aProp := {;
"Access",;
"Automount",;
"Availability",;
"BlockSize",;
"BootVolume",;
"Capacity",;
"Caption",;
"Compressed",;
"ConfigManagerErrorCode",;
"ConfigManagerUserConfig",;
"CreationClassName",;
"Description",;
"DeviceID",;
"DirtyBitSet",;
"DriveLetter",;
"DriveType",;
"ErrorCleared",;
"ErrorDescription",;
"ErrorMethodology",;
"FileSystem",;
"FreeSpace",;
"IndexingEnabled",;
"InstallDate",;
"Label",;
"LastErrorCode",;
"MaximumFileNameLength",;
"Name",;
"NumberOfBlocks",;
"PageFilePresent",;
"PNPDeviceID",;
"PowerManagementCapabilities",;
"PowerManagementSupported",;
"Purpose",;
"QuotasEnabled",;
"QuotasIncomplete",;
"QuotasRebuilding",;
"SerialNumber",;
"Status",;
"StatusInfo",;
"SupportsDiskQuotas",;
"SupportsFileBasedCompression",;
"SystemCreationClassName",;
"SystemName",;
"SystemVolume" }

DEFAULT strComputer TO "Localhost"
DEFAULT cUser       TO "Administrator"
DEFAULT cPassword   TO ""

   CLS

   SET ALTER TO Win32_Volume.TXT
   SET ALTER ON

   IF VAL( OS(OS_VERSION) ) > 6
      IF strComputer == "Localhost"
         objWMIServices  := CreateObject( "WbemScripting.SWbemLocator" ):ConnectServer(strComputer, "Root\CIMv2")
      ELSE
         IF EMPTY(cPassword)
            MSGBOX("Need Password")
            QUIT
         ELSE
            objWMIServices  := CreateObject( "WbemScripting.SWbemLocator" ):ConnectServer(strComputer, "Root\CIMv2",strComputer+"\"+cUser,cPassword)
         ENDIF
      ENDIF
   ELSE
      objWMIServices  := GetObject("WinMgmts:{impersonationLevel=impersonate}\\"+strComputer+"\Root\CIMv2") 
   ENDIF

   colItems       := objWMIServices:ExecQuery("select * from Win32_Volume",,48)
   bCollBlock     := {|oService,n| AADD(aItem,{ n,;
     oService:getProperty("Access"),;
     oService:getProperty("Automount"),;
     oService:getProperty("Availability"),;
     oService:getProperty("BlockSize"),;
     oService:getProperty("BootVolume"),;
     oService:getProperty("Capacity"),;
     oService:getProperty("Caption"),;
     oService:getProperty("Compressed"),;
     oService:getProperty("ConfigManagerErrorCode"),;
     oService:getProperty("ConfigManagerUserConfig"),;
     oService:getProperty("CreationClassName"),;
     oService:getProperty("Description"),;
     oService:getProperty("DeviceID"),;
     oService:getProperty("DirtyBitSet"),;
     oService:getProperty("DriveLetter"),;
     oService:getProperty("DriveType"),;
     oService:getProperty("ErrorCleared"),;
     oService:getProperty("ErrorDescription"),;
     oService:getProperty("ErrorMethodology"),;
     oService:getProperty("FileSystem"),;
     oService:getProperty("FreeSpace"),;
     oService:getProperty("IndexingEnabled"),;
     oService:getProperty("InstallDate"),;
     oService:getProperty("Label"),;
     oService:getProperty("LastErrorCode"),;
     oService:getProperty("MaximumFileNameLength"),;
     oService:getProperty("Name"),;
     oService:getProperty("NumberOfBlocks"),;
     oService:getProperty("PageFilePresent"),;
     oService:getProperty("PNPDeviceID"),;
     oService:getProperty("PowerManagementCapabilities"),;
     oService:getProperty("PowerManagementSupported"),;
     oService:getProperty("Purpose"),;
     oService:getProperty("QuotasEnabled"),;
     oService:getProperty("QuotasIncomplete"),;
     oService:getProperty("QuotasRebuilding"),;
     oService:getProperty("SerialNumber"),;
     oService:getProperty("Status"),;
     oService:getProperty("StatusInfo"),;
     oService:getProperty("SupportsDiskQuotas"),;
     oService:getProperty("SupportsFileBasedCompression"),;
     oService:getProperty("SystemCreationClassName"),;
     oService:getProperty("SystemName"),;
     oService:getProperty("SystemVolume") })}

   ComEvalCollection(colItems, bCollBlock )

   IF LEN(aItem) > 0
      ? "Win32_Volume"
      jMax := LEN(aItem)
      iMax := LEN(aItem[1])
      FOR j := 1 TO jMax
         ?"*****************************************************************************"
         FOR i := 1 TO iMax-1
            ? SUBSTR(aProp[i]+SPACE(40),1,40)+":",aItem[j,i+1]
         NEXT
         ?"*****************************************************************************"
      NEXT
   ELSE
      MSGBOX("no Property found ?")
   ENDIF

   objWMIServices:Destroy()
   objWMIServices := NIL

   SET ALTER OFF
   SET ALTER TO

   Runshell("Win32_Volume.TXT","Notepad.exe",.T.)

RETURN
