#include "common.ch"
#include "os.ch"
#define CRLF CHR(13)+CHR(10)

#PRAGMA LIBRARY("ASCOM10.LIB")


PROCEDURE Main(strComputer,cUser,cPassword)
LOCAL objWMIServices
LOCAL colItems
LOCAL cText
LOCAL cName
LOCAL bCollBlock
LOCAL i,iMax
LOCAL j,jMax
LOCAL aitem := {}
LOCAL aProp := {;
"Caption",;
"CreationClassName",;
"Depth",;
"Description",;
"Height",;
"HotSwappable",;
"InstallDate",;
"Location",;
"Manufacturer",;
"MaxCapacity",;
"MaxCapacityEx",;
"MemoryDevices",;
"MemoryErrorCorrection",;
"Model",;
"Name",;
"OtherIdentifyingInfo",;
"PartNumber",;
"PoweredOn",;
"Removable",;
"Replaceable",;
"SerialNumber",;
"SKU",;
"Status",;
"Tag",;
"Use",;
"Version",;
"Weight",;
"Width" }

DEFAULT strComputer TO "Localhost"
DEFAULT cUser       TO "Administrator"
DEFAULT cPassword   TO ""

   CLS

   SET ALTER TO Win32_PhysicalMemoryArray.TXT
   SET ALTER ON

   IF VAL( OS(OS_VERSION) ) > 6
      IF strComputer == "Localhost"
         objWMIServices  := CreateObject( "WbemScripting.SWbemLocator" ):ConnectServer(strComputer, "Root\CIMv2")
      ELSE
         IF EMPTY(cPassword)
            MSGBOX("Need Password")
            QUIT
         ELSE
            objWMIServices  := CreateObject( "WbemScripting.SWbemLocator" ):ConnectServer(strComputer, "Root\CIMv2",strComputer+"\"+cUser,cPassword)
         ENDIF
      ENDIF
   ELSE
      objWMIServices  := GetObject("WinMgmts:{impersonationLevel=impersonate}\\"+strComputer+"\Root\CIMv2") 
   ENDIF

   colItems       := objWMIServices:ExecQuery("select * from Win32_PhysicalMemoryArray",,48)
   bCollBlock     := {|oService,n| AADD(aItem,{ n,;
     oService:getProperty("Caption"),;
     oService:getProperty("CreationClassName"),;
     oService:getProperty("Depth"),;
     oService:getProperty("Description"),;
     oService:getProperty("Height"),;
     oService:getProperty("HotSwappable"),;
     oService:getProperty("InstallDate"),;
     oService:getProperty("Location"),;
     oService:getProperty("Manufacturer"),;
     oService:getProperty("MaxCapacity"),;
     oService:getProperty("MaxCapacityEx"),;
     oService:getProperty("MemoryDevices"),;
     oService:getProperty("MemoryErrorCorrection"),;
     oService:getProperty("Model"),;
     oService:getProperty("Name"),;
     oService:getProperty("OtherIdentifyingInfo"),;
     oService:getProperty("PartNumber"),;
     oService:getProperty("PoweredOn"),;
     oService:getProperty("Removable"),;
     oService:getProperty("Replaceable"),;
     oService:getProperty("SerialNumber"),;
     oService:getProperty("SKU"),;
     oService:getProperty("Status"),;
     oService:getProperty("Tag"),;
     oService:getProperty("Use"),;
     oService:getProperty("Version"),;
     oService:getProperty("Weight"),;
     oService:getProperty("Width") })}

   ComEvalCollection(colItems, bCollBlock )

   IF LEN(aItem) > 0
      ? "Win32_PhysicalMemoryArray"
      jMax := LEN(aItem)
      iMax := LEN(aItem[1])
      FOR j := 1 TO jMax
         ?"*****************************************************************************"
         FOR i := 1 TO iMax-1
            ? SUBSTR(aProp[i]+SPACE(40),1,40)+":",aItem[j,i+1]
         NEXT
         ?"*****************************************************************************"
      NEXT
   ELSE
      MSGBOX("no Property found ?")
   ENDIF

   objWMIServices:Release()
   objWMIServices:Destroy()
   objWMIServices := NIL

   SET ALTER OFF
   SET ALTER TO

   Runshell("Win32_PhysicalMemoryArray.TXT","Notepad.exe",.T.)

RETURN
